@import "@assets/themes/themify.utils.scss";
@import "~/themes.scss";

/**
  Hide input[type='number'] default browser style
  @see https://stackoverflow.com/questions/3790935/can-i-hide-the-html5-number-input-s-spin-box
*/
%InputWithoutSpin {
  appearance: textfield; /* Firefox */

  &::-webkit-outer-spin-button,
  &::-webkit-inner-spin-button {
    /* display: none; <- Crashes Chrome on hover */
    appearance: none;
    margin: 0; /* <-- Apparently some margin are still there even though it's hidden */
  }
}

.InputNumber {
  height: 40px;
  font-size: 14px;
  text-rendering: optimizelegibility;

  input { all: unset; }

  &:not(&-without-buttons) {
    display: grid;
    grid-template-columns: [decrement] 50px [field] auto [increment] 50px;
    grid-column-gap: 4px;
  }

  &-without-buttons .InputNumberField {
    height: calc(100% - 4px) !important;
  }

  &-disabled {
    * { cursor: not-allowed !important; }
  }

  .InputNumberFieldWrapper {
    grid-area: field;
    height: 100%;
  }

  button {
    height: calc(40px - 4px);
  }

  .InputNumberField {
    border: 2px solid;

    @extend %InputWithoutSpin;

    height: calc(100% - 4px);
    width: calc(100% - 4px);
    min-width: 50px;
    cursor: text;
    border-radius: 4px;
    text-align: center;
    color: #ebebeb;
  }
}

@include themify("InputNumber", $themes) {
  font-family: themed("font-family");

  .InputNumberField {
    background-color: themed("field-background-editable");
    border-color: themed("field-background-editable");

    &:hover,
    &:focus-within {
      border-color: themed("field-focused");
    }
  }

  &.InputNumber {
    &-disabled .InputNumberField {
      color: themed("field-text-disabled");
      background-color: themed("field-background-disabled");
      border-color: themed("field-background-disabled");
    }

    &-danger .InputNumberField {
      border-color: themed("field-danger");

      &:hover,
      &:focus-within {
        border-color: themed("field-danger");
      }
    }

    &-busy .InputNumberField {
      border-color: themed("field-busy");

      &:hover,
      &:focus-within {
        border-color: themed("field-busy");
      }
    }
  }
}
